1. 程式人生 > 實用技巧 >systemctl管理指令碼-nginx

systemctl管理指令碼-nginx

systemctl管理指令碼-nginx

Ⅰ.介紹

systemctl指令碼存放在:/usr/lib/systemd/,有系統(system)和使用者(user)之分

  • 1、/usr/lib/systemd/system #系統服務,開機不需要登陸就能執行的程式(相當於開啟自啟)

  • 2、/usr/lib/systemd/user #使用者服務,需要登入後才能執行的程式

/usr/lib/systemd/目錄下又存在兩種型別的檔案:

  • 1、*.service # 服務unit檔案

  • 2、*.target # 開機級別unit

centos7 的每一個服務以.service 結尾,一般分為3部分:【unit】、【service】、【install】

[Unit]   # 主要是服務說明 
Description=test    # 簡單描述服務 
After=network.target    # 描述服務類別,表示本服務需要在network服務啟動後在啟動 
Before=xxx.service   #表示需要在某些服務啟動之前啟動,After和Before欄位只涉及啟動順序,不涉 及依賴關係。 
 
[Service]    # 核心區域 
Type=forking   # 表示後臺執行模式。 
User=user      # 設定服務執行的使用者 
Group=user     # 設定服務執行的使用者組 
KillMode=control-group    # 定義systemd如何停止服務 
PIDFile=/usr/local/test/test.pid    # 存放PID的絕對路徑 
Restart=no     # 定義服務程序退出後,systemd的重啟方式,預設是不重啟 
ExecStart=/usr/local/test/bin/startup.sh    # 服務啟動命令,命令需要絕對路徑 
PrivateTmp=true    # 表示給服務分配獨立的臨時空間 
 
[Install] WantedBy=multi-user.target    # 多使用者

欄位詳細說明

1.Type型別:

simple(預設):#以Execstart欄位啟動的程序為主程序 
forking:     #Execstart 欄位以fox()方式啟動,,此時父程序將退出,子程序將成為主程序(後臺運 行),一般都設定為forking 
oneshot :    #類似於simple,但只執行一次,systemd會等他執行完,才執行其他服務 
dbus:       #類似於simple,但會等待D—Bus訊號後啟動 
notify:     #類似與simple ,但結束後會發出通知訊號,然後systemd才啟動其他服務 
idle:       #類似與simple,但要等到其他任務都執行完,才啟動該服務

2.EnvironmentFile:

指定配置檔案,和連詞號組合使用,可以避免配置檔案不存在的異常。

Environment: 
後面接多個不同的shell變數。 
例如: 
Environment=DATA_DIR=/data/elk 
Environment=LOG_DIR=/var/log/elasticsearch 
Environment=PID_DIR=/var/run/elasticsearch 
EnvironmentFile=-/etc/sysconfig/elasticsearch 
 
連詞號(-):在所有啟動設定之前,新增的變數欄位,都可以加上連詞號 表示抑制錯誤,即發生錯誤時,不影響其他命令的執行。 
比如EnviromentFile=-/etc/sysconfig/xxx表示即使檔案不存在,也不會拋異常

3.Killmode的型別:

contorl-group (預設) # 當前控制組裡所有的子程序都會被殺掉 
process : #只殺主程序 
mixed: #主程序將收到SIGTERM(終止程序)訊號,子程序將收到SIGKILL(無條件終止)訊號 
none: # 沒有程序會被殺掉,只是執行服務的stop命令

4.Restart型別:

no (預設):   #退出後無操作 
on-success :  #只有正常退出時(退出狀態碼為0),才會重啟 
on-failure:   #非正常退出時,重啟,包括訊號終止,和超時 
on-abnaomal:  #只有訊號終止或超時,才會重啟 
on-abort :   #只有在收到沒有捕捉到訊號終止時,才會重啟 
on-watchdog:  #超市退出時,才會重啟 a
lways:        #不管什麼退出原因,都會重啟 
 
#對於守護程序,推薦使用on-failure

5.RestartSec:

表示systemd重啟服務之前,需要等待的秒數:RestartSec:30

6.各種Exec*欄位:

Exec*後面的命令,僅接受‘指令 引數 引數..’格式,不能接受<> |&等特殊字元,很多bash語法也不支 持,如果想要支援bash語法,需要設定Tyep=oneshot 
# ExecStart:    # 啟動服務時執行的命令 
# ExecReload:   # 重啟服務時執行的命令 
# ExecStop:     # 停止服務時執行的命令 
# ExecStartPre: # 啟動服務前執行的命令 
# ExecStartPost:# 啟動服務後執行的命令 
# ExecStopPost: # 停止服務後執行的命令 
# PrivateTmp=True #表示給服務分配獨立的臨時空間, 
# 注意:[Service]部分的啟動、重啟、停止命令全部要求使用絕對路徑,使用相對路徑則會報錯! 
 
[Service] 
Type=forking 
PIDFile=/home/developer/web/gunicorn.pid 
ExecStart=/usr/local/bin/forever start 
ExecReload=/bin/kill -s HUP $MAINPID 
ExecStop=/bin/kill -s QUIT $MAINPID 
PrivateTmp=true

7.[Install]

部分是服務安裝的相關設定,可設定為多使用者的

[Install] 
WantedBy=multi-user.target 
# WantedBy欄位: 
# multi-user.target: # 表示多使用者命令列狀態,這個設定很重要 
# graphical.target:  # 表示圖形使用者狀體,它依賴於multi-user.target

8.生效

修改配置檔案以後,以754的許可權儲存在/usr/lib/systemd/system目錄下,需要重新載入配置檔案方可生效

$ systemctl daemon-reload

這時就可以利用systemctl進行配置了

首先,使用systemctl start [服務名(也是檔名)]可測試服務是否可以成功執行,如果不能執行則可以使用systemctl status [服務名(也是檔名)]檢視錯誤資訊和其他服務資訊,然後根據報錯進行修改,直到可以start,如果不放心還可以測試restart和stop命令。

接著,只要使用systemctl enable xxxxx就可以將所編寫的服務新增至開機啟動即可。

Ⅱ.nginx指令碼實操

systemctl管理指令碼一般針對原始碼安裝的服務

1.編寫nginx控制指令碼

編寫指令碼如下,並且保證指令碼有可執行許可權

#!/bin/bash 
. /etc/init.d/functions
args=$1 
fun(){
[ $? -eq 0 ] && action "Nginx $args is " /bin/true || echo "Nginx $args is " /bin/false 
}
 
case $1 in 
   start)
         netstat -lntup|grep ":80\b" &>/dev/null 
         if [ $? -eq 0 ];then
             echo "Nginx is runing..." 
         else
             /usr/local/nginx/sbin/nginx   #nginx命令的路徑
             fun 
         fi
         ;; 
   stop)
        /usr/local/nginx/sbin/nginx -s stop 
        fun 
        ;; 
   reload) 
         /usr/local/nginx/sbin/nginx -s reload 
         fun 
         ;; 
   restart) 
         netstat -lntup|grep ":80\b" &>/dev/null 
         if [ $? -ne 0 ];then
             /usr/local/nginx/sbin/nginx 
             [ $? -eq 0 ] && echo "Nginx start is ok" || echo "Nginx start is failed"
         else
             /usr/local/nginx/sbin/nginx -s stop 
             [ $? -eq 0 ] && echo "Nginx stop is ok" || echo "Nginx stop is failed" 
             sleep 2 
             /usr/local/nginx/sbin/nginx 
             fun 
          fi
          ;; 
   status) 
          netstat -lntup|grep ":80\b" &>/dev/null 
          if [ $? -eq 0 ];then
              echo "Nginx is runing ..." 
          else
              echo "Nginx is not runing ..." 
          fi
          ;; 
   *) 
          echo "Usage: $0 {start|stop|status|restart|reload}" 
          exit 2 
esac
 
 
 
#測試指令碼
[root@aliyun /scripts]# sh nginx.sh start
Nginx start is                                             [  OK  ]
[root@aliyun /scripts]# sh nginx.sh restart
Nginx stop is ok
Nginx restart is                                           [  OK  ]
[root@aliyun /scripts]# sh nginx.sh reload
Nginx reload is                                            [  OK  ]
[root@aliyun /scripts]# sh nginx.sh status
Nginx is runing ...
[root@aliyun /scripts]# sh nginx.sh stop
Nginx stop is                                              [  OK  ]
[root@aliyun /scripts]# sh nginx.sh status
Nginx is not runing ...

2.配置

[root@aliyun ~]# cat /usr/lib/systemd/system/nginx.service 
[Unit] 
Description=Nginx server daemon 
 
[Service] 
Type=forking 
ExecStart=/scripts/nginx.sh start 
ExecStop=/scripts/nginx.sh stop 
ExecReload=/scripts/nginx.sh reload 
ExecRestart=/scripts/nginx.sh restart
Execstatus=/scripts/nginx.sh status
PrivateTmp=true 
 
[Install] 
WantedBy=multi-user.target

3.重新載入

systemctl daemon-reload

4.測試

[root@aliyun /scripts]# systemctl start nginx
[root@aliyun /scripts]# systemctl stop nginx
[root@aliyun /scripts]# systemctl status nginx
● nginx.service - Nginx server daemon
   Loaded: loaded (/usr/lib/systemd/system/nginx.service; disabled; vendor preset: disabled)
   Active: active (running) since Mon 2020-09-07 20:18:47 CST; 5s ago
  Process: 61361 ExecStart=/scripts/nginx.sh start (code=exited, status=0/SUCCESS)
 Main PID: 61367 (nginx)
   CGroup: /system.slice/nginx.service
           ├─61367 nginx: master process /usr/local/nginx/sbin/nginx
           └─61369 nginx: worker process
 
Sep 07 20:18:47 web01 systemd[1]: [/usr/lib/systemd/system/nginx.service:9] Unknown lvalue 'ExecRestart' ...vice'
Sep 07 20:18:47 web01 systemd[1]: [/usr/lib/systemd/system/nginx.service:10] Unknown lvalue 'Execstatus' ...vice'
Sep 07 20:18:47 web01 systemd[1]: Starting Nginx server daemon...
Sep 07 20:18:47 web01 nginx.sh[61361]: Nginx start is  [  OK  ]
Sep 07 20:18:47 web01 systemd[1]: Started Nginx server daemon.
Hint: Some lines were ellipsized, use -l to show in full.